/*

*/

CREATE OR REPLACE PROCEDURE VALIDA_PARAM_FISCAL_OL
(P_NRERFISCALOL IN ERROFISCALOL.NRERFISCALOL%TYPE,
 P_CDFILIOPELOG IN PARAMPRODSUP.CDFILIOPELOG%TYPE,
 P_CDFILDEST    IN FILIAL.CDFILIAL%TYPE,
 P_CDTIPOOPER   IN TIPOOPERAC.CDTIPOOPER%TYPE,
 P_IDENTRSAIDOP IN TIPOOPERAC.IDENTRSAIDOP%TYPE,
 P_CDARVPROD    IN PRODUTO.CDARVPROD%TYPE,
 P_CDMARCA      IN MARCA.CDMARCA%TYPE,
 P_DTERFISCALOL IN NOTAFISCAL.DTENTRSAID%TYPE,
 P_DTEMBRFISCOL IN NOTAFISCAL.DTENTRSAID%TYPE)

AS
   V_IDORIGDESTNF    VARCHAR2(01);
   V_CDGRUPOFISC     VARCHAR2(03);
   V_CDGRUPOFISCAUX  VARCHAR2(03);
   V_CDEMPRESA       VARCHAR2(02);
   V_CDINSCESTA      VARCHAR2(16);
   V_IDINTEREST      VARCHAR2(01);
   V_IDINTERNA       VARCHAR2(01);
   V_IDENDCFOP       VARCHAR2(01);
   V_PAISORIG        VARCHAR2(04);
   V_ESTAORIG        VARCHAR2(02);
   V_MUNIORIG        VARCHAR2(04);
   V_PAISDEST        VARCHAR2(04);
   V_ESTADEST        VARCHAR2(02);
   V_MUNIDEST        VARCHAR2(04);
   V_IDENDEMIS       VARCHAR2(01);
   V_PAISCFOP       VARCHAR2(04);
   V_ESTACFOP       VARCHAR2(02);

   V_CDIMPOTEMP      VARCHAR2(02);
   V_CDFISCTEMP      VARCHAR2(01);
   V_IDTRATIMPTMP    VARCHAR2(01);
   V_IDUTMUNIORIG    VARCHAR2(01);
   V_IDCONSISTENT    VARCHAR2(01);
   V_IDIMPORECUP     VARCHAR2(01);
   V_IDUTVLRQTDEIMPO VARCHAR2(01);
   V_MODDOCFISC      VARCHAR2(02);
   V_FISOPEITEM      VARCHAR2(11);

   V_CDSITTRIBTMP    CODSITUTRIBNFE.CDSITUTRIBNFE%TYPE;
   V_IDMODBCNFE      CODSITUTRIBNFE.IDMODBCNFE%TYPE;
   V_IDMOTIDESSTNFE  CODSITUTRIBNFE.IDMOTIDESSTNFE%TYPE;
   V_IDMODBCSTNFE    CODSITUTRIBNFE.IDMODBCSTNFE%TYPE;
   V_CDTPCRPICOSTNFE CODSITUTRIBNFE.CDTPCRPICOSTNFE%TYPE;
   V_CDNATUBCPCSTNFE CODSITUTRIBNFE.CDNATUBCPCSTNFE%TYPE;
   V_ENTRSAIDOP      VARCHAR2(01);
   V_CDTIPOOPER      VARCHAR2(02);
   V_CDPRODARVOL     VARCHAR2(10);
   V_CHAVE           VARCHAR2(18);
   V_CDPRODUTO       VARCHAR2(10);
BEGIN

   DELETE FROM ERROFISCALOL
   WHERE CDFILIOPELOG = P_CDFILIOPELOG
     AND CDFILDEST = P_CDFILDEST
     AND CDARVPRODER = P_CDARVPROD
     AND DTERFISCALOL = P_DTERFISCALOL;

   V_ENTRSAIDOP := P_IDENTRSAIDOP;
   V_CDTIPOOPER := P_CDTIPOOPER;

   IF V_ENTRSAIDOP = 'S' THEN /*SAIDAS DO OPERADOR LOGISTICO*/
      SELECT DECODE(P_IDENTRSAIDOP , 'S', NVL(MAX(IDORIGDESTOP), 'C'), NVL(MAX(IDORIGDESTOP), 'F'))
        INTO V_IDORIGDESTNF
        FROM TIPOOPERAC
       WHERE IDENTRSAIDOP = P_IDENTRSAIDOP
         AND CDTIPOOPER = V_CDTIPOOPER;

      CONSULTA_GRUPOFISCAL(V_IDORIGDESTNF, P_CDFILDEST, P_CDFILIOPELOG, P_IDENTRSAIDOP, V_CDTIPOOPER, V_CDGRUPOFISC);

      SELECT NVL(MAX(IDENDCFOPFIL),'I'), MAX(CDEMPRESA), MAX(CDINSCESTA)
        INTO V_IDENDCFOP, V_CDEMPRESA, V_CDINSCESTA
        FROM FILIAL
       WHERE CDFILIAL = P_CDFILIOPELOG;

      IF V_IDENDCFOP = 'I' THEN
         Begin
            SELECT CDPAIS    , SGESTADO  , CDMUNICIPIO
            INTO   V_PAISORIG, V_ESTAORIG, V_MUNIORIG
            FROM INSCRESTAD
            WHERE CDEMPRESA  = V_CDEMPRESA AND
                  CDINSCESTA = V_CDINSCESTA;
         Exception
            When No_Data_Found Then
               V_PAISORIG := Null; V_ESTAORIG := Null; V_MUNIORIG := Null;
         End;
      ELSE
         Begin
            SELECT CDPAIS    , SGESTADO  , CDMUNICIPIO
            INTO   V_PAISORIG, V_ESTAORIG, V_MUNIORIG
            FROM ENDEFILI
            WHERE (CDFILIAL     = P_CDFILIOPELOG) AND
                  (IDTPENDEFILI = V_IDENDCFOP);
         Exception
            When No_Data_Found Then
               V_PAISORIG := Null; V_ESTAORIG := Null; V_MUNIORIG := Null;
         End;
      END IF;

      SELECT NVL(MAX(IDENDCFOPFIL),'I'), NVL(MAX(IDENDEMISFIL),'I')
        INTO V_IDENDCFOP, V_IDENDEMIS
        FROM FILIAL
       WHERE (CDFILIAL = P_CDFILDEST);

      IF V_IDENDCFOP = 'I' THEN
         Begin
            SELECT CDPAIS    , SGESTADO
            INTO   V_PAISCFOP, V_ESTACFOP
            FROM INSCRESTAD
            WHERE CDEMPRESA  = V_CDEMPRESA AND
                  CDINSCESTA = V_CDINSCESTA;
         Exception
            When No_Data_Found Then
               V_PAISCFOP := Null; V_ESTACFOP := Null;
         End;
      ELSE
         Begin
            SELECT CDPAIS    , SGESTADO
            INTO   V_PAISCFOP, V_ESTACFOP
            FROM ENDEFILI
            WHERE (CDFILIAL     = P_CDFILDEST) AND
                  (IDTPENDEFILI = V_IDENDCFOP);
         Exception
            When No_Data_Found Then
               V_PAISCFOP := Null; V_ESTACFOP := Null;
         End;
      END IF;

      IF V_IDENDEMIS = 'I' THEN
         Begin
            SELECT CDPAIS    , SGESTADO  , CDMUNICIPIO
              INTO   V_PAISDEST, V_ESTADEST, V_MUNIDEST
              FROM INSCRESTAD
             WHERE CDEMPRESA  = V_CDEMPRESA AND
                   CDINSCESTA = V_CDINSCESTA;
         Exception
            When No_Data_Found Then
               V_PAISDEST := Null; V_ESTADEST := Null; V_MUNIDEST := Null;
            End;
      ELSE
         Begin
            SELECT CDPAIS    , SGESTADO  , CDMUNICIPIO
              INTO   V_PAISDEST, V_ESTADEST, V_MUNIDEST
              FROM ENDEFILI
              WHERE CDFILIAL     = P_CDFILDEST AND
                    IDTPENDEFILI = V_IDENDEMIS;
          Exception
             When No_Data_Found Then
                V_PAISDEST := Null; V_ESTADEST := Null; V_MUNIDEST := Null;
          End;
      END IF;

      V_IDINTEREST := 'N';
      V_IDINTERNA  := 'N';
      IF ((V_PAISDEST = V_PAISORIG) AND (V_ESTADEST <> V_ESTAORIG)) THEN
         V_IDINTEREST := 'S';
      ELSIF (V_PAISDEST <> V_PAISORIG) THEN
         V_IDINTERNA := 'S';
      END IF;


      SELECT MAX(P.CDARVPROD)
        INTO V_CDPRODARVOL
        FROM RELACPRODOL, PRODUTO, PRODUTO P
       WHERE RELACPRODOL.CDPRARVORIG = PRODUTO.CDPRODUTO
         AND PRODUTO.CDARVPROD = P_CDARVPROD
         AND CDMARCA = P_CDMARCA
         AND RELACPRODOL.CDPRODARVOL = P.CDPRODUTO;

      IF V_CDPRODARVOL IS NULL THEN
         INSERT INTO ERROFISCALOL
            (NRERFISCALOL, CDFILIOPELOG, CDFILDEST, IDENTRSAIDOP,
             CDTIPOOPER, CDARVPRODER, CDERRO, CDIMPOSTO,
             DTERFISCALOL, CDEMPRESAOL, CDINSCESTAOL, DTEMBRFISCOL)
         VALUES
            (P_NRERFISCALOL, P_CDFILIOPELOG, P_CDFILDEST, V_ENTRSAIDOP,
             V_CDTIPOOPER, P_CDARVPROD, 'SEMPROL', null,
             P_DTERFISCALOL, V_CDEMPRESA, V_CDINSCESTA, P_DTEMBRFISCOL);
      ELSE
         V_CHAVE := P_CDFILIOPELOG||P_CDFILDEST||P_NRERFISCALOL;

         CONSULTA_CFOP(V_ENTRSAIDOP, V_CDEMPRESA, V_CDPRODARVOL, V_CDINSCESTA, P_CDTIPOOPER, V_PAISORIG,
                       V_ESTAORIG, V_PAISCFOP, V_ESTACFOP, P_CDFILIOPELOG, P_CDFILDEST||P_NRERFISCALOL, V_CDGRUPOFISC, P_DTERFISCALOL);

         SELECT MAX(CDFISOPETMP)
           INTO V_FISOPEITEM
           FROM CFOPTEMP
          WHERE NRCFOPTEMP = V_CHAVE;

         IF V_FISOPEITEM IS NULL THEN
            INSERT INTO ERROFISCALOL
               (NRERFISCALOL, CDFILIOPELOG, CDFILDEST, IDENTRSAIDOP,
                CDTIPOOPER, CDARVPRODER, CDERRO, CDIMPOSTO,
                DTERFISCALOL, CDEMPRESAOL, CDINSCESTAOL, DTEMBRFISCOL)
            VALUES
               (P_NRERFISCALOL, P_CDFILIOPELOG, P_CDFILDEST, V_ENTRSAIDOP,
                V_CDTIPOOPER, V_CDPRODARVOL, 'SEMCFOP', null,
                P_DTERFISCALOL, V_CDEMPRESA, V_CDINSCESTA, P_DTEMBRFISCOL);
         END IF;

         SELECT MIN(CDMODDOCFISC)
           INTO V_MODDOCFISC
           FROM MODDOCFISCTPOP
          WHERE CDTIPOOPER   = V_CDTIPOOPER
            AND IDENTRSAIDOP = V_ENTRSAIDOP;

         IF V_MODDOCFISC IS NULL THEN
            INSERT INTO ERROFISCALOL
               (NRERFISCALOL, CDFILIOPELOG, CDFILDEST, IDENTRSAIDOP,
                CDTIPOOPER, CDARVPRODER, CDERRO, CDIMPOSTO,
                DTERFISCALOL, CDEMPRESAOL, CDINSCESTAOL, DTEMBRFISCOL)
               VALUES
               (P_NRERFISCALOL, P_CDFILIOPELOG, P_CDFILDEST, V_ENTRSAIDOP,
                V_CDTIPOOPER, V_CDPRODARVOL, 'SEMMODFIS', null,
                P_DTERFISCALOL, V_CDEMPRESA, V_CDINSCESTA, P_DTEMBRFISCOL);
         END IF;

         CONSULTA_INCIDENCIA(V_ENTRSAIDOP, V_CDEMPRESA, V_CDPRODARVOL, V_CDINSCESTA, V_CDTIPOOPER, P_CDFILIOPELOG, P_CDFILDEST||P_NRERFISCALOL, V_CDGRUPOFISC,
                             NULL, V_IDINTEREST, 'PED', P_CDFILIOPELOG, NULL, NULL,  P_DTEMBRFISCOL, P_CDFILDEST);

         FOR C_IMPOSOBRIG IN (SELECT I.CDIMPOSTO, IM.IDPRODNOTA, IM.SGIMPOSTO
                                FROM IMPOBRIGTPOPER I, IMPOSTO IM
                               WHERE I.IDENTRSAIDOP = V_ENTRSAIDOP
                                 AND I.CDTIPOOPER = V_CDTIPOOPER
                                 AND IM.CDIMPOSTO = I.CDIMPOSTO) LOOP

               SELECT DISTINCT MAX(CDIMPOTEMP) AS CDIMPOTEMP, MAX(CDFISCTEMP), MAX(IDTRATIMPTMP), MAX(IDUTMUNIORIG),
                      MAX(IDCONSISTENT), MAX(IDIMPORECUP), MAX(IDUTVLRQTDEIMPO)
                 INTO V_CDIMPOTEMP, V_CDFISCTEMP, V_IDTRATIMPTMP, V_IDUTMUNIORIG,
                      V_IDCONSISTENT, V_IDIMPORECUP, V_IDUTVLRQTDEIMPO
                 FROM INCITEMP IT, IMPOSTO IP
                WHERE (IT.NRINCITEMP = V_CHAVE)    AND
                      (IP.CDIMPOSTO  = IT.CDIMPOTEMP) AND
                      (IT.CDIMPOTEMP = C_IMPOSOBRIG.CDIMPOSTO) AND
                      (IP.IDPRODNOTA = 'P')
               ORDER BY CDIMPOTEMP;

               IF V_CDIMPOTEMP IS NULL THEN
                  INSERT INTO ERROFISCALOL
                     (NRERFISCALOL, CDFILIOPELOG, CDFILDEST, IDENTRSAIDOP,
                      CDTIPOOPER, CDARVPRODER, CDERRO, CDIMPOSTO,
                      DTERFISCALOL, CDEMPRESAOL, CDINSCESTAOL, DTEMBRFISCOL)
                     VALUES
                     (P_NRERFISCALOL, P_CDFILIOPELOG, P_CDFILDEST, V_ENTRSAIDOP,
                      V_CDTIPOOPER, V_CDPRODARVOL, 'SEMIMPOBRI', C_IMPOSOBRIG.CDIMPOSTO,
                      P_DTERFISCALOL, V_CDEMPRESA, V_CDINSCESTA, P_DTEMBRFISCOL);
               END IF;
         END LOOP;

         FOR C_INCIDENCIA IN (SELECT DISTINCT (CDIMPOTEMP) AS CDIMPOTEMP, CDFISCTEMP, IDTRATIMPTMP, IDUTMUNIORIG,
                                              IDCONSISTENT, IDIMPORECUP, IDUTVLRQTDEIMPO
                                FROM INCITEMP IT, IMPOSTO IP
                               WHERE (IT.NRINCITEMP = V_CHAVE)    AND
                                     (IP.CDIMPOSTO  = IT.CDIMPOTEMP) AND
                                     (IP.IDPRODNOTA = 'P')
                              ORDER BY CDIMPOTEMP) LOOP


            V_CDGRUPOFISCAUX := NULL;

            SELECT MAX(G.CDGRUPOFISC)
              INTO V_CDGRUPOFISCAUX
              FROM GRUPOFISCIMPFIL G
             WHERE G.CDFILIAL = P_CDFILIOPELOG
               AND NOT G.CDGRUPOFISC IS NULL
               AND G.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP;


            IF V_CDGRUPOFISCAUX IS NULL THEN
               CONSULTA_CST_NFE(V_ENTRSAIDOP, V_CDEMPRESA, V_CDPRODARVOL, V_CDINSCESTA, V_CDTIPOOPER, V_CDGRUPOFISC,C_INCIDENCIA.CDIMPOTEMP, V_IDINTEREST, V_IDINTERNA, P_CDFILIOPELOG, P_CDFILDEST||P_NRERFISCALOL, '',  V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE);
            ELSE
               CONSULTA_CST_NFE(V_ENTRSAIDOP, V_CDEMPRESA, V_CDPRODARVOL, V_CDINSCESTA, V_CDTIPOOPER, V_CDGRUPOFISCAUX,C_INCIDENCIA.CDIMPOTEMP, V_IDINTEREST, V_IDINTERNA, P_CDFILIOPELOG, P_CDFILDEST||P_NRERFISCALOL, '', V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE);
            END IF;

            IF V_CDSITTRIBTMP IS NULL THEN
               INSERT INTO ERROFISCALOL
                  (NRERFISCALOL, CDFILIOPELOG, CDFILDEST, IDENTRSAIDOP,
                   CDTIPOOPER, CDARVPRODER, CDERRO, CDIMPOSTO,
                   DTERFISCALOL, CDEMPRESAOL, CDINSCESTAOL, DTEMBRFISCOL)
                  VALUES
                  (P_NRERFISCALOL, P_CDFILIOPELOG, P_CDFILDEST, V_ENTRSAIDOP,
                   V_CDTIPOOPER, V_CDPRODARVOL, 'SEMCSTNFE', C_INCIDENCIA.CDIMPOTEMP,
                   P_DTERFISCALOL, V_CDEMPRESA, V_CDINSCESTA, P_DTEMBRFISCOL);
            END IF;

            IF C_INCIDENCIA.CDFISCTEMP IS NULL THEN
               INSERT INTO ERROFISCALOL
                  (NRERFISCALOL, CDFILIOPELOG, CDFILDEST, IDENTRSAIDOP,
                   CDTIPOOPER, CDARVPRODER, CDERRO, CDIMPOSTO,
                   DTERFISCALOL, CDEMPRESAOL, CDINSCESTAOL, DTEMBRFISCOL)
                  VALUES
                  (P_NRERFISCALOL, P_CDFILIOPELOG, P_CDFILDEST, V_ENTRSAIDOP,
                   V_CDTIPOOPER, V_CDPRODARVOL, 'SEMCF', C_INCIDENCIA.CDIMPOTEMP,
                   P_DTERFISCALOL, V_CDEMPRESA, V_CDINSCESTA, P_DTEMBRFISCOL);
            END IF;
         END LOOP;

         DELETE FROM INCITEMP
         WHERE NRINCITEMP = V_CHAVE;

         DELETE CFOPTEMP
          WHERE NRCFOPTEMP = V_CHAVE;
      END IF;
   END IF;

   IF V_ENTRSAIDOP = 'S' THEN
      V_ENTRSAIDOP := 'E';
      SELECT MAX(CDTIPOOPERENTR)
        INTO V_CDTIPOOPER
        FROM TIPOOPEROPL
       WHERE CDFILIOPELOG = P_CDFILIOPELOG
         AND CDFILDEST = P_CDFILDEST;
   END IF;

   IF V_ENTRSAIDOP = 'E' THEN /* ENTRADAS DO OPERADOR LOGSTICO*/

      SELECT DECODE(P_IDENTRSAIDOP , 'S', NVL(MAX(IDORIGDESTOP), 'C'), NVL(MAX(IDORIGDESTOP), 'F'))
        INTO V_IDORIGDESTNF
        FROM TIPOOPERAC
       WHERE IDENTRSAIDOP = V_ENTRSAIDOP
         AND CDTIPOOPER = V_CDTIPOOPER;

      CONSULTA_GRUPOFISCAL(V_IDORIGDESTNF, P_CDFILIOPELOG, P_CDFILDEST, P_IDENTRSAIDOP, V_CDTIPOOPER, V_CDGRUPOFISC);

      SELECT MAX(CDEMPRESA), MAX(CDINSCESTA)
        INTO V_CDEMPRESA, V_CDINSCESTA
        FROM FILIAL
       WHERE CDFILIAL = P_CDFILDEST;

      BEGIN
         SELECT CDPAIS,     SGESTADO,   CDMUNICIPIO
         INTO   V_PAISDEST, V_ESTADEST, V_MUNIDEST
         FROM INSCRESTAD
         WHERE (CDEMPRESA  = V_CDEMPRESA) AND
               (CDINSCESTA = V_CDINSCESTA);
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_PAISDEST := NULL; V_ESTADEST := NULL; V_MUNIDEST := NULL;
      END;

      SELECT NVL(MAX(IDENDCFOPFIL),'I')
        INTO   V_IDENDCFOP
        FROM FILIAL
       WHERE (CDFILIAL = P_CDFILIOPELOG);

      IF V_IDENDCFOP = 'I' THEN
         BEGIN
            SELECT CDPAIS    , SGESTADO
            INTO   V_PAISCFOP, V_ESTACFOP
            FROM INSCRESTAD
            WHERE CDEMPRESA  = V_CDEMPRESA AND
                  CDINSCESTA = V_CDINSCESTA;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_PAISCFOP := NULL; V_ESTACFOP := NULL;
         END;
      ELSE
         BEGIN
            SELECT CDPAIS, SGESTADO
            INTO V_PAISCFOP, V_ESTACFOP
            FROM ENDEFILI
            WHERE (CDFILIAL     = P_CDFILIOPELOG) AND
                  (IDTPENDEFILI = 'P');
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_PAISCFOP := NULL; V_ESTACFOP := NULL;
         END;
      END IF;

      BEGIN
         SELECT CDPAIS, SGESTADO, CDMUNICIPIO
           INTO V_PAISORIG, V_ESTAORIG, V_MUNIORIG
           FROM ENDEFILI
          WHERE (CDFILIAL     = P_CDFILIOPELOG) AND
                (IDTPENDEFILI = 'P');
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_PAISORIG := NULL; V_ESTAORIG := NULL; V_MUNIORIG := NULL;
      END;

      V_IDINTEREST := 'N';
      V_IDINTERNA  := 'N';
      IF ((V_PAISDEST = V_PAISORIG) AND (V_ESTADEST <> V_ESTAORIG)) THEN
         V_IDINTEREST := 'S';
      ELSIF (V_PAISDEST <> V_PAISORIG) THEN
         V_IDINTERNA := 'S';
      END IF;

      V_CHAVE := P_CDFILDEST||P_CDFILIOPELOG||P_NRERFISCALOL;

      CONSULTA_CFOP(V_ENTRSAIDOP, V_CDEMPRESA, P_CDARVPROD, V_CDINSCESTA, V_CDTIPOOPER, V_PAISCFOP,
                    V_ESTACFOP, V_PAISDEST, V_ESTADEST, P_CDFILDEST, P_CDFILIOPELOG||P_NRERFISCALOL, V_CDGRUPOFISC, P_DTERFISCALOL);

      SELECT MAX(CDFISOPETMP)
        INTO V_FISOPEITEM
        FROM CFOPTEMP
       WHERE NRCFOPTEMP = V_CHAVE;

      IF V_FISOPEITEM IS NULL THEN
         INSERT INTO ERROFISCALOL
            (NRERFISCALOL, CDFILIOPELOG, CDFILDEST, IDENTRSAIDOP,
             CDTIPOOPER, CDARVPRODER, CDERRO, CDIMPOSTO,
             DTERFISCALOL, CDEMPRESAFI, CDINSCESTAFI, DTEMBRFISCOL)
         VALUES
            (P_NRERFISCALOL, P_CDFILIOPELOG, P_CDFILDEST, V_ENTRSAIDOP,
             V_CDTIPOOPER, P_CDARVPROD, 'SEMCFOP', null,
             P_DTERFISCALOL, V_CDEMPRESA, V_CDINSCESTA, P_DTEMBRFISCOL);
      END IF;

      SELECT MIN(CDMODDOCFISC)
        INTO V_MODDOCFISC
        FROM MODDOCFISCTPOP
       WHERE CDTIPOOPER   = V_CDTIPOOPER
         AND IDENTRSAIDOP = V_ENTRSAIDOP;

      IF V_MODDOCFISC IS NULL THEN
         INSERT INTO ERROFISCALOL
            (NRERFISCALOL, CDFILIOPELOG, CDFILDEST, IDENTRSAIDOP,
             CDTIPOOPER, CDARVPRODER, CDERRO, CDIMPOSTO,
             DTERFISCALOL, CDEMPRESAFI, CDINSCESTAFI, DTEMBRFISCOL)
            VALUES
            (P_NRERFISCALOL, P_CDFILIOPELOG, P_CDFILDEST, V_ENTRSAIDOP,
             V_CDTIPOOPER, P_CDARVPROD, 'SEMMODFIS', null,
             P_DTERFISCALOL, V_CDEMPRESA, V_CDINSCESTA, P_DTEMBRFISCOL);
      END IF;

      CONSULTA_INCIDENCIA(V_ENTRSAIDOP, V_CDEMPRESA, P_CDARVPROD, V_CDINSCESTA, V_CDTIPOOPER, P_CDFILDEST, P_CDFILIOPELOG||P_NRERFISCALOL, V_CDGRUPOFISC, NULL,
                          V_IDINTEREST, 'PED', P_CDFILDEST, NULL, NULL, P_DTEMBRFISCOL, P_CDFILIOPELOG);


      FOR C_IMPOSOBRIG IN (SELECT I.CDIMPOSTO, IM.IDPRODNOTA, IM.SGIMPOSTO
                                FROM IMPOBRIGTPOPER I, IMPOSTO IM
                               WHERE I.IDENTRSAIDOP = V_ENTRSAIDOP
                                 AND I.CDTIPOOPER = V_CDTIPOOPER
                                 AND IM.CDIMPOSTO = I.CDIMPOSTO) LOOP

            SELECT DISTINCT MAX(CDIMPOTEMP) AS CDIMPOTEMP, MAX(CDFISCTEMP), MAX(IDTRATIMPTMP), MAX(IDUTMUNIORIG),
                   MAX(IDCONSISTENT), MAX(IDIMPORECUP), MAX(IDUTVLRQTDEIMPO)
              INTO V_CDIMPOTEMP, V_CDFISCTEMP, V_IDTRATIMPTMP, V_IDUTMUNIORIG,
                   V_IDCONSISTENT, V_IDIMPORECUP, V_IDUTVLRQTDEIMPO
              FROM INCITEMP IT, IMPOSTO IP
             WHERE (IT.NRINCITEMP = V_CHAVE)    AND
                   (IP.CDIMPOSTO  = IT.CDIMPOTEMP) AND
                   (IT.CDIMPOTEMP = C_IMPOSOBRIG.CDIMPOSTO) AND
                   (IP.IDPRODNOTA = 'P')
            ORDER BY CDIMPOTEMP;

            IF V_CDIMPOTEMP IS NULL THEN
               INSERT INTO ERROFISCALOL
                  (NRERFISCALOL, CDFILIOPELOG, CDFILDEST, IDENTRSAIDOP,
                   CDTIPOOPER, CDARVPRODER, CDERRO, CDIMPOSTO,
                   DTERFISCALOL, CDEMPRESAFI, CDINSCESTAFI, DTEMBRFISCOL)
                  VALUES
                  (P_NRERFISCALOL, P_CDFILIOPELOG, P_CDFILDEST, V_ENTRSAIDOP,
                   V_CDTIPOOPER, P_CDARVPROD, 'SEMIMPOBRI', C_IMPOSOBRIG.CDIMPOSTO,
                   P_DTERFISCALOL, V_CDEMPRESA, V_CDINSCESTA, P_DTEMBRFISCOL);
            END IF;
      END LOOP;

      FOR C_INCIDENCIA IN (SELECT DISTINCT (CDIMPOTEMP) AS CDIMPOTEMP, CDFISCTEMP, IDTRATIMPTMP, IDUTMUNIORIG,
                                           IDCONSISTENT, IDIMPORECUP, IDUTVLRQTDEIMPO
                             FROM INCITEMP IT, IMPOSTO IP
                            WHERE (IT.NRINCITEMP = V_CHAVE)    AND
                                  (IP.CDIMPOSTO  = IT.CDIMPOTEMP) AND
                                  (IP.IDPRODNOTA = 'P')
                           ORDER BY CDIMPOTEMP) LOOP


         V_CDGRUPOFISCAUX := NULL;

         SELECT MAX(G.CDGRUPOFISC)
           INTO V_CDGRUPOFISCAUX
           FROM GRUPOFISCIMPFIL G
          WHERE G.CDFILIAL = P_CDFILDEST
            AND NOT G.CDGRUPOFISC IS NULL
            AND G.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP;


         IF V_CDGRUPOFISCAUX IS NULL THEN
            CONSULTA_CST_NFE(V_ENTRSAIDOP, V_CDEMPRESA, P_CDARVPROD, V_CDINSCESTA, V_CDTIPOOPER, V_CDGRUPOFISC,C_INCIDENCIA.CDIMPOTEMP, V_IDINTEREST, V_IDINTERNA, P_CDFILDEST , P_CDFILIOPELOG||P_NRERFISCALOL, '', V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE);
         ELSE
            CONSULTA_CST_NFE(V_ENTRSAIDOP, V_CDEMPRESA, P_CDARVPROD, V_CDINSCESTA, V_CDTIPOOPER, V_CDGRUPOFISCAUX,C_INCIDENCIA.CDIMPOTEMP, V_IDINTEREST, V_IDINTERNA, P_CDFILDEST, P_CDFILIOPELOG||P_NRERFISCALOL, '', V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE);
         END IF;

         IF V_CDSITTRIBTMP IS NULL THEN
            INSERT INTO ERROFISCALOL
               (NRERFISCALOL, CDFILIOPELOG, CDFILDEST, IDENTRSAIDOP,
                CDTIPOOPER, CDARVPRODER, CDERRO, CDIMPOSTO,
                DTERFISCALOL, CDEMPRESAFI, CDINSCESTAFI, DTEMBRFISCOL)
               VALUES
               (P_NRERFISCALOL, P_CDFILIOPELOG, P_CDFILDEST, V_ENTRSAIDOP,
                V_CDTIPOOPER, P_CDARVPROD, 'SEMCSTNFE', C_INCIDENCIA.CDIMPOTEMP,
                P_DTERFISCALOL, V_CDEMPRESA, V_CDINSCESTA, P_DTEMBRFISCOL);
         END IF;

         IF C_INCIDENCIA.CDFISCTEMP IS NULL THEN
            INSERT INTO ERROFISCALOL
               (NRERFISCALOL, CDFILIOPELOG, CDFILDEST, IDENTRSAIDOP,
                CDTIPOOPER, CDARVPRODER, CDERRO, CDIMPOSTO,
                DTERFISCALOL, CDEMPRESAFI, CDINSCESTAFI, DTEMBRFISCOL)
               VALUES
               (P_NRERFISCALOL, P_CDFILIOPELOG, P_CDFILDEST, V_ENTRSAIDOP,
                V_CDTIPOOPER, P_CDARVPROD, 'SEMCF', C_INCIDENCIA.CDIMPOTEMP,
                P_DTERFISCALOL, V_CDEMPRESA, V_CDINSCESTA, P_DTEMBRFISCOL);
         END IF;
      END LOOP;

      DELETE FROM INCITEMP
      WHERE NRINCITEMP = V_CHAVE;

      DELETE CFOPTEMP
       WHERE NRCFOPTEMP = V_CHAVE;
   END IF;
END;
/

-- VERSAO --
BEGIN atuverobj('VALIDA_PARAM_FISCAL_OL','5.50.xxx'); END;
/
