/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_MUNI                                                     */
/* Tabela : MUNICIPIO                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_MUNI'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_MUNI
GO

CREATE TRIGGER DTULTATU_MUNI
ON MUNICIPIO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'MUNICIPIO', null, 'CDPAIS='  + CDPAIS  + ';' +
                                        'SGESTADO='+ SGESTADO+ ';' +
                                        'CDMUNICIPIO=' + CDMUNICIPIO + ';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE MUNICIPIO
      SET DTULTATUMUNI = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(MUNICIPIO.CDPAIS,0)      = ISNULL(INSERTED.CDPAIS,0))      AND
            (ISNULL(MUNICIPIO.SGESTADO,0)    = ISNULL(INSERTED.SGESTADO,0))    AND
            (ISNULL(MUNICIPIO.CDMUNICIPIO,0) = ISNULL(INSERTED.CDMUNICIPIO,0)) AND
            (ISNULL(MUNICIPIO.NMMUNICIPIO,0) = ISNULL(INSERTED.NMMUNICIPIO,0)) AND
            (ISNULL(MUNICIPIO.CDREGIAO,0)    = ISNULL(INSERTED.CDREGIAO,0))    AND
            (ISNULL(MUNICIPIO.CDMUNICIBGE,0) = ISNULL(INSERTED.CDMUNICIBGE,0)) AND
            (ISNULL(MUNICIPIO.CDMUNIEXPO,0)  = ISNULL(INSERTED.CDMUNIEXPO,0));
   END;
END;
GO

UPDATE MUNICIPIO SET DTULTATUMUNI = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUMUNI IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUMUNI' and
            type = 'D')
   ALTER TABLE MUNICIPIO DROP CONSTRAINT DEFAULT_DTULTATUMUNI
GO

ALTER TABLE MUNICIPIO ADD CONSTRAINT DEFAULT_DTULTATUMUNI
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUMUNI
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_MUNI','4.11.194';
GO
