<?php
namespace Teknisa\Model\Teknisa\Repositories;

use \Teknisa\Model\Teknisa\Entities;

class CpCallAttachment extends \Doctrine\ORM\EntityRepository {

    public function getCallAttachmentsDataSet($callId) {
        $query = <<<SQL
            SELECT ATT.NRCALLATTACHMENT AS ID, ATT.NRORG,ATT.LABEL,  ATT.FILENAME, ATT.FILETYPE AS FILE_TYPE, ATT.FILESIZE, ATT.CALL,
                   TO_CHAR(ATT.DTINCLUSAO, 'DD/MM/YYYY') AS CREATED_AT, OP.NMOPERADOR AS CREATED_BY
            FROM CP_CALL_ATTACHMENT ATT
            INNER JOIN OPERADOR OP ON OP.CDOPERADOR = ATT.CDOPERINCLUSAO
            WHERE ATT.CALL = :CALL_ID
SQL;

        $params = array(
            'CALL_ID' => $callId
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }
    public function getAttachmentsByCallId($callId, $fileServerUrl = '') {
        $query = <<<SQL
         SELECT  '$fileServerUrl'||ATT.FILENAME AS FILENAME, ATT.NRCALLATTACHMENT AS ID, ATT.LABEL,
                  ATT.FILETYPE AS FILE_TYPE, TO_CHAR(ATT.DTINCLUSAO, 'DD/MM/YYYY') AS CREATED_AT,
				  OP.NMOPERADOR AS CREATED_BY,
                  ATT.DTINCLUSAO AS CREATED_AT_DATETIME
		   FROM CP_CALL_ATTACHMENT ATT
           JOIN OPERADOR OP ON OP.CDOPERADOR = ATT.CDOPERINCLUSAO
		  WHERE ATT.CALL = :CALL_ID
	   ORDER BY ATT.DTINCLUSAO
SQL;

        $params = array(
            'CALL_ID' => $callId
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function getTaskAttachmentsExceptUploadedBy($issueId,$fileServerUrl) {
        $query = <<<SQL
		  SELECT  '$fileServerUrl'||ATT.FILE_NAME AS FILENAME, ATT.ID, ATT.LABEL, TASK.NAME, ATT.TYPE_FILE AS FILE_TYPE, TO_CHAR(ATT.CREATED_AT, 'DD/MM/YYYY') AS CREATED_AT,
				  RES.NAME AS CREATED_BY
		  FROM 			ATTACHMENT ATT
		  INNER JOIN 	RESOURCE_T RES 	ON (RES.ID = ATT.CREATED_BY)
		  LEFT JOIN 	TASK 			ON (TASK.ID = ATT.TASK)
		  WHERE  ATT.TASK = :ID_TASK
		  ORDER BY ATT.CREATED_AT
SQL;

        $params = array(
            'ID_TASK' => $issueId
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function getCallAttachmentsRelationships($callId) {
        $query = <<<SQL
            SELECT LISTAGG(CA.CALL_RELATIONSHIP_ATTACHMENT, ',') WITHIN GROUP(ORDER BY CA.CALL_RELATIONSHIP_ATTACHMENT) as CALL_RELATIONSHIP_LIST
            FROM CP_CALL_ATTACHMENT CA
            WHERE CA.CALL = :CALL_ID
            GROUP BY CA.CALL
SQL;

        $params = array(
            'CALL_ID' => $callId
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function getAllAttachmentsFolder($nrsoliserv,$basicIntranetFileDir, $cdClienteBase,
                                            $isTeknisaFunc,$filename = ''){
        $directorySeparator = DIRECTORY_SEPARATOR;

        $filter = '';
        if (!$isTeknisaFunc) {
            $filter = <<<SQL
         AND (SOL.CDCLIENTE = :cdClienteBase OR NOT(OP.CDCLIENTE = :cdClienteBase AND OPR.CDCLIENTE = :cdClienteBase))
SQL;
        }
        $filterFolder = '';
        if($filename){
            $filterFolder = "AND $filename = TO_CHAR(LFT.DTALFASETRAM,'YYYYMMDDHH24MISS')";
        }

        $query = <<<SQL
			SELECT '$basicIntranetFileDir'||'$directorySeparator'||LFT.NRSOLISERV||'$directorySeparator'|| TO_CHAR(LFT.DTALFASETRAM,'YYYYMMDDHH24MISS')||'$directorySeparator' AS DIR
			FROM LOGFASETRAM LFT
                 LEFT JOIN OPERADOR OP  ON OP.CDOPERADOR  = LFT.CDOPERADOR
                 LEFT JOIN OPERADOR OPR ON OPR.CDOPERADOR = LFT.CDOPERRESP
                INNER JOIN SOLISERV SOL ON SOL.NRSOLISERV = :NRSOLISERV
                     WHERE LFT.NRSOLISERV = :NRSOLISERV
                     $filterFolder
                     $filter
SQL;
        $params = array(
            'NRSOLISERV' => $nrsoliserv,
            "cdClienteBase" => $cdClienteBase
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function downLoadAttachmentTicket($id) {
        $query =
            <<<SQL
            SELECT CAN.NRANEXOCONTATO AS ID,
                   CAN.DSCAMINHO AS FILENAME, NUll AS FILE_TYPE, NMARQUIVO||'.'||DSTIPO AS LABEL,
                   CAN.VRTAMANHO AS SIZEFILE,DSTIPO
              FROM CRM_ANEXOCONTATO CAN
             WHERE CAN.NRANEXOCONTATO = :ID
SQL;

        $params = array(
            "ID" => $id
        );

        $result = $this->getEntityManager()->getConnection()->fetchAll($query, $params);
        return empty($result) ? null : $result[0];
    }

}