import { Metadata } from '@zeedhi/core';
import { TekGrid } from '@zeedhi/teknisa-components-common';
import { Form, Select } from '@zeedhi/common';
import { ZdFileInput, ZdSelectTree, ZdTextInput } from '@zeedhi/vuetify';

export class InstanceService {
	public static getInstanceTekGrid(name: string): TekGrid {
		return Metadata.getInstance<TekGrid>(name);
	}

	public static getInstanceZdForm(name: string): Form {
		return Metadata.getInstance<Form>(name);
	}

	public static getInstanceZdTextInput(name: string): ZdTextInput {
		return Metadata.getInstance<ZdTextInput>(name);
	}

	public static getInstanceZdSelect(name: string): Select {
		return Metadata.getInstance<Select>(name);
	}

	public static getInstanceZdSelectTree(name: string): ZdSelectTree {
		return Metadata.getInstance<ZdSelectTree>(name);
	}

	public static getInstanceZdFileInput(name: string): ZdFileInput {
		return Metadata.getInstance<ZdFileInput>(name);
	}

	public checkIfSelectIsSelected(name: string) {
		try {
			const select = Metadata.getInstance<Select>(name);
			return !!Object.keys(select.selectedData).length;
		} catch (error) {
			return false;
		}
	}
}
